# Black Desert (script 0.2.5) modified by Garkin
#
#  My modifications are based on BlackFire's modified script:
#  https://www.undertow.club/posts/129096
#
#  Original script:
#  http://aluigi.altervista.org/bms/blackdesert.bms
#
# If you are using Notepad++, change the Language to "Visual Basic" to get a nice color code

quickbmsver "0.7.4"

# Defines the compression type that will be used, when extracting a file
comtype blackdesert

# Sets the encryption key we are going to use later
set BDO_ICE_KEY binary "\x51\xF3\x0F\x11\x04\x24\x6A\x00"
encryption ice BDO_ICE_KEY

# gets the extension of the opened file
get EXT extension

#If the file extension is .meta
if EXT == "meta"
# pre-allocation, improves speed (doesn't matter if the values are bigger)
   putarray 0 0x4000 ""   # Array that is going to store the PAZs names
   putarray 1 0x2000 ""   # Array that is going to store the folder names
   putarray 2 0x80000 ""  # Array that is going to store the file names

   # Reads the first 4 bytes (long) of the meta file and stores it in the variable VERSION. (In C: fread(&version,sizeof(long),1,metaFile);)
   get VERSION long
   
   # Reads how many PAZ files your game has. (In C: fread(&pPAZCount,sizeof(long),1,metaFile);)
   get pPAZCount long

   # Paz files informations
   for i = 0 < pPAZCount
       get PAZ_NUM long
       get HASH long
       get PAZ_SIZE long

	   # Using the number stored in PAZ_NUM with 5 digits,creates a string that will hold the complete .PAZ file name (E.g.:PAD00001.PAZ) (In C: sprintf(paz_name,"PAD%.5d.PAZ",paz_num);)
       string PAZ_NAME p= "PAD%05d.PAZ" PAZ_NUM
	   
	   # Stores in the array 0 in the position [PAZ_NUM], the string we just created (In C: array0[paz_num] = paz_name;)
       putarray 0 PAZ_NUM PAZ_NAME
   next i

   # Reads how many files your game has. (In C: fread(&files_count,sizeof(long),1,metaFile)
   get FILES_COUNT long
   
   # Saves the current position in the file in a variable. This position is the beginning of the blocks that have the following format: HASH|FOLDER_NUM|FILE_NUM|PAZ_NUM|OFFSET|ZSIZE|SIZE # (In C: long file_blocks_start = ftell(metafile);)
   savepos FILE_BLOCKS_START
   
   # Calculates the position which is where the file blocks ended (each file block has 28 bytes (7 * sizeof(long)) (In C: long file_blocks_end = (current pos - 7 * sizeof(long));)
   xmath FILE_BLOCKS_END "FILE_BLOCKS_START + (FILES_COUNT * 7 * 4)"
   
   # Moves the file pointer to the end of the File Blocks, skipping the whole File Blocks section for now
   goto FILE_BLOCKS_END

   # Gets the total length of the strings that are comming next, that are the folder names strings (In C: fread(&folder_names_total_length,sizeof(long),1,metaFile);)
   get FOLDER_NAMES_TOTAL_LENGTH long
   
   # Saves the position where the folder names strings start (In C: long folder_names_start = ftell(fp);)
   savepos FOLDER_NAMES_START
   
   # Saves all the next "FOLDER_NAMES_TOTAL_LENGTH" bytes, starting from the offset "FOLDER_NAMES_START" in a temporary memory called MEMORY_FILE (In C: fread(memory_file,1,folder_names_total_length,metaFile);)
   log MEMORY_FILE FOLDER_NAMES_START FOLDER_NAMES_TOTAL_LENGTH

   # Calculates which byte the folder names strings end (In C: long folder_names_end = folder_names_start + folders_name_total_length;)
   xmath FOLDER_NAMES_END "FOLDER_NAMES_START + FOLDER_NAMES_TOTAL_LENGTH"
   
   # Goes to that position (In C: fseek(metaFile,folder_names_end,SEEK_SET);)
   goto FOLDER_NAMES_END

   # Gets the total length of the strings that are comming next, that are the file names strings (In C: fread(&file_names_total_length,sizeof(long),1,metaFile);)
   get FILE_NAMES_TOTAL_LENGTH long
   
   # Saves the position where the file names strings start (In C: long file_names_start = ftell(fp);)
   savepos FILE_NAMES_START

   # Saves all the next "FILE_NAMES_TOTAL_LENGTH" bytes, starting from the offset "FILE_NAMES_START" in a temporary memory called MEMORY_FILE2 (In C: fread(memory_file2,1,file_names_total_length,metaFile);)
   log MEMORY_FILE2 FILE_NAMES_START FILE_NAMES_TOTAL_LENGTH

   # Don't know why, but it ignores the last 8 bytes of the folder names string (2 irrelevent longs, maybe?)
   math FOLDER_NAMES_TOTAL_LENGTH -= 8

   # Reads the string which has all the folder names, assigning each folder name to a different position in the array 1 (folders array)
   math i = 0
   for TMP = 0 < FOLDER_NAMES_TOTAL_LENGTH
       get INDEX_NUM long MEMORY_FILE		# Reads from the MEMORY_FILE the the index number of the current folder
       get SUB_FOLDERS long MEMORY_FILE		# Reads from the MEMORY_FILE the number of subfolder of the current folder
       get FOLDER_NAME string MEMORY_FILE	# Reads from the MEMORY_FILE a folder name, as string, until a '\0' is found. E.g: "character/"

	   # If no name was read, means that we reached the end of the folder names
       if FOLDER_NAME == ""
           break
       endif

	   # Stores the folder name, in the position i of the array 1 (folders array) (In C: array1[i] = folder_name;)
       putarray 1 i FOLDER_NAME
	   
	   # Updates TMP with the current position we are going to read now in MEMORY_FILE, this is just so the "for" condition stops when we reach "FOLDER_NAMES_TOTAL_LENGTH"
       savepos TMP MEMORY_FILE
   next i

   math i = 0
   # Reads the string which has all the file names, assigning each file name to a different position in the array 2 (files array)
   for TMP = 0 < FILE_NAMES_TOTAL_LENGTH   
	   # Reads from the MEMORY_FILE a file name, as string, until a '\0' is found.
       get FILE_NAME string MEMORY_FILE2	
	
	   # If no name was read, means that we reached the end of the file names
       if FILE_NAME == ""
           break
       endif
	   
	   # Stores the folder name, in the position i of the array 1 (folders array) (In C: array1[i] = file_name;)
       putarray 2 i FILE_NAME
	   
	   # Updates TMP with the current position we are going to read now in MEMORY_FILE
       savepos TMP MEMORY_FILE2
   next i
    
   # Now we are going to extract the files, combining the information we find in the file blocks, with the arrays filled with the file and folder names	

   # Goes back to the beginning of the file blocks
   goto FILE_BLOCKS_START
   
   
   # For each File Block
   for i = 0 < FILES_COUNT 
       get HASH long		# Gets the unique indentifier of this file
       get FOLDER_NUM long  # Gets the index in the array 1 (folders array) which has the folder name from this file
       get FILE_NUM long    # Gets the index in the array 2 (files array) which has the file name from this file
       get PAZ_NUM long		# Gets the number of the .PAZ file that the file is located
       get OFFSET long		# Gets the offset inside the .PAZ file specified which the file starts
       get ZSIZE long		# Gets the compressed size of the file
       get SIZE long		# Gets the uncompressed size of the file

	   # Gets the PAZ name at the position [PAZ_NUM] of the array 0 (PAZ names array) and stores is in the PAZ_NAME variable (In C: paz_name     = array0[paz_num])
       getarray PAZ_NAME 0 PAZ_NUM	
	   
	   # Gets the folder name at the position [FOLDER_NUM] of the array 1 (folders array) and stores is in the FOLDER_NAME variable (In C: folder_name = array1[paz_num];)
       getarray FOLDER_NAME 1 FOLDER_NUM
	   
	   # Gets the file name at the position [FILE_NUM] of the array 1 (folders array) and stores is in the FILE_NAME variable (In C: file_name     = array2[paz_num];)
       getarray FILE_NAME 2 FILE_NUM
	   
	   # Creates a string and concatenates folder name with the file name strings, so we get the full path to the file. Eg: "character/multiplemodeldesc.xml"
       string FILE_PATH = FOLDER_NAME
       string FILE_PATH += FILE_NAME

	   # Opens the .PAZ file specified in the PAZ_NAME variable
       open FDSE PAZ_NAME 1

	   # If uncompressed size is greater than compressed size, it means that the file is compressed, so we use "clog" which uncompresses and extracts the file
       if SIZE > ZSIZE
		   clog FILE_PATH OFFSET ZSIZE SIZE 1
	       # FILE_PATH: The path with the file name in the end, where the file will be extracted. Example: character/multiplemodeldesc.xml
		   # OFFSET   : The byte in this .PAZ file which the compressed encrypted file starts
		   # ZSIZE    : The size of the file should be when still compressed
		   # SIZE     : The the file should be, when decompressed
           # 1        : Number of the file associated to the archive
		   
	   # If the uncompressed size is 0 (Yes there are files with 0 size)
       elseif SIZE == 0
		   # Extract the file without decompressing it, and it will have 0 bytes
           log FILE_PATH 0 0
		   
	   # If uncompressed smaller than the compressed size
       else 
	       # Extracts the file temporaryly in memory so we can do a check first, without decompressing it
           log MEMORY_FILE3 OFFSET ZSIZE 1
		   
		   # Gets the first byte from the extracted file to do a check
           get FLAGS byte MEMORY_FILE3
		   
		   	#Even if decompression algorithm supports header where is size stored as byte, this method is not used in .paz files,
			#so it is safe to omit this method. Valid IDs for method where size is stored as long are 0x6E for uncompressed data
			#and 0x6F for compressed data. Also we have to make sure that data contains at least whole header (9 bytes)
			if (FLAGS == 0x6E || FLAGS == 0x6F) && ZSIZE > 9
				get DUMMY long MEMORY_FILE3 #read compressed data size, I have called variable DUMMY because we don't use it
				get SIZE2 long MEMORY_FILE3 #read decompressed data size
			endif
		   
		   encryption "" ""                 #turn off encryption because data in MEMORY_FILE3 are already decrypted
			if SIZE == SIZE2                #if decompressed size from .paz/.meta file is the same as decompressed size from data header, 
											#we will consider data header as valid and data can be sent to decompression function										
				clog FILE_PATH 0 ZSIZE SIZE MEMORY_FILE3    #send file to decompression function and store result to specified file
			else                            #if data header is not valid, data are uncompressed without header
				log FILE_PATH 0 SIZE MEMORY_FILE3           #store data with length SIZE to specified file
			endif
			encryption ice BDO_ICE_KEY      #turn encryption back on
       endif
   next i

# Same thing as the .meta extension, but if you open a .PAZ file to extract
else if EXT == "PAZ"  #If the file extension is .PAZ
   get DUMMY long
   get TOTAL_FILES long
   get FILE_PATHS_TOTAL_LENGTH long

   savepos FILE_BLOCKS_START
   xmath FILE_BLOCKS_END "FILE_BLOCKS_START + (TOTAL_FILES * 4 * 6)"
   log MEMORY_FILE FILE_BLOCKS_END FILE_PATHS_TOTAL_LENGTH

   math i = 0
   for TMP = 0 < FILE_PATHS_TOTAL_LENGTH
       get FILE_PATH string MEMORY_FILE

       if FILE_PATH == ""
           break
       endif

       putarray 0 i FILE_PATH
       savepos TMP MEMORY_FILE
   next i

   for i = 0 < TOTAL_FILES
       get HASH long
       get FOLDER_NUM long
       get FILE_NUM long
       get OFFSET long
       get ZSIZE long
       get SIZE long

       getarray FOLDER_NAME 0 FOLDER_NUM
       getarray FILE_NAME 0 FILE_NUM
       string FILE_PATH = FOLDER_NAME
       string FILE_PATH += FILE_NAME

       if SIZE > ZSIZE
           clog FILE_PATH OFFSET ZSIZE SIZE
       elseif SIZE == 0
           log FILE_PATH 0 0
       else
           log MEMORY_FILE2 OFFSET ZSIZE
           get FLAGS byte MEMORY_FILE2
		   
			if (FLAGS == 0x6E || FLAGS == 0x6F) && ZSIZE > 9
				get DUMMY long MEMORY_FILE2
				get SIZE2 long MEMORY_FILE2
			endif
		   
           encryption "" ""
           	if SIZE == SIZE2               							
				clog FILE_PATH 0 ZSIZE SIZE MEMORY_FILE2    
			else                     
				log FILE_PATH 0 SIZE MEMORY_FILE2          
			endif
			encryption ice BDO_ICE_KEY   
       endif
   next i

endif